// #autoload
// #name = Commander map fix
// #version = 1.0.1
// #date = 2004-05-22
// #author = Ben Winslow
// #warrior = Raineth
// #description = Fixes crashes when right-clicking on terrain in map (Linux)
// #status = release
// #readme = scripts/autoexec/rain/txt/commandermapfix.txt
// #category = Rain's scripts

package commanderMapFix {
	function GuiCommanderMap::getCommandType(%this, %typeTag)
	{
		// rain - sometimes, terrain clicks will cause a stack address to
		// be passed in %typeTag...  Since the stack address tends to have
		// the sign bit set, and the tag functions crash when given a
		// negative tag number, we kluge this into a terrain click in
		// that case.
		if (%typeTag < 0)
			return('Location');
		
		// other times, it'll return a bad tag (with an empty string)
		if (getTaggedString(%typeTag) $= "")
			return('Location');

		return parent::getCommandType(%this, %typeTag);
	}
};

activatePackage(commanderMapFix);
